SystemOrganization addCategory: #'Voyage-Model-Core'!

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 11/2/2010 16:56'!
isNew: anObject 
	^self isPersistent 
		ifTrue: [ self repository isNew: anObject ]
		ifFalse: [ false ]! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EL 7/23/2008 12:45'!
isPersistent
	^false! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EL 1/28/2009 19:44'!
persistentClass
	self == Object ifTrue: [ ^false ]. 
	(self class selectors includes: #isPersistent)
		ifTrue: [ ^self ] 
		ifFalse: [ ^self superclass persistentClass ]! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EL 7/23/2008 12:45'!
remove: anObject
	self isPersistent ifTrue: [ self repository remove: anObject ]! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 10/13/2011 14:00'!
removeAll 
	self repository removeAll: self! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EL 7/23/2008 12:34'!
repository
	^VORepository current! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EL 11/11/2008 14:36'!
save: anObject
	self isPersistent 
		ifTrue: [ ^self repository save: anObject ]
		ifFalse: [ ^anObject ]! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 10/29/2009 10:35'!
selectAll
	^self repository selectAll: self
! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 10/29/2009 10:34'!
selectAllSortBy: sortBlock
	^self repository selectAll: self sortBy: sortBlock
! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 10/29/2009 10:50'!
selectMany: aBlock
	^self repository selectMany: self where: aBlock! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 10/29/2009 10:34'!
selectMany: aBlock sortBy: sortBlock
	^self repository selectMany: self where: aBlock sortBy: sortBlock! !

!Class methodsFor: '*Voyage-Model-Core' stamp: 'EL 7/23/2008 13:04'!
selectOne: aBlock
	^self repository selectOne: self where: aBlock! !

Error subclass: #VOError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Model-Core'!

!VOError commentStamp: 'EstebanLorenzano 10/26/2011 10:03' prior: 0!
I'm a model for all voyage errors !

!Object methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 11/2/2010 16:58'!
isNew 
	^self class isNew: self! !

!Object methodsFor: '*Voyage-Model-Core' stamp: 'EL 1/28/2009 19:34'!
persistentClass
	^self class persistentClass! !

!Object methodsFor: '*Voyage-Model-Core' stamp: 'EL 7/23/2008 12:44'!
remove
	^self class remove: self! !

!Object methodsFor: '*Voyage-Model-Core' stamp: 'EL 7/23/2008 12:43'!
save
	^self class save: self
! !

!Object methodsFor: '*Voyage-Model-Core' stamp: 'EstebanLorenzano 11/8/2011 14:30'!
update 
	self isNew ifFalse: [ self save ]! !

Object subclass: #VORepository
	instanceVariableNames: ''
	classVariableNames: 'RepositoryContainer RepositoryContainerClass'
	poolDictionaries: ''
	category: 'Voyage-Model-Core'!

!VORepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/15/2010 11:51'!
collectionClass 
	^OrderedCollection! !

!VORepository class methodsFor: 'accessing' stamp: 'EL 7/7/2008 18:40'!
current
	^self repositoryContainer repository! !

!VORepository class methodsFor: 'defaults' stamp: 'EL 7/7/2008 18:44'!
defaultAccessStrategyClass
	^ VOSingletonContainer! !

!VORepository class methodsFor: 'defaults' stamp: 'EL 7/7/2008 18:44'!
defaultRepositoryContainerClass
	^ VOSingletonContainer! !

!VORepository class methodsFor: 'accessing' stamp: 'EL 7/7/2008 18:41'!
repositoryContainer
	^RepositoryContainer
		ifNil: [ RepositoryContainer := self repositoryContainerClass new ]! !

!VORepository class methodsFor: 'accessing' stamp: 'EL 7/7/2008 18:39'!
repositoryContainerClass
	^RepositoryContainerClass 
		ifNil: [ RepositoryContainerClass := self defaultRepositoryContainerClass ]! !

!VORepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/15/2010 10:33'!
reset! !

!VORepository class methodsFor: 'accessing' stamp: 'EL 7/7/2008 18:40'!
setRepository: aRepository
	self repositoryContainer repository: aRepository! !

!VORepository methodsFor: 'persistence' stamp: 'EL 7/3/2008 08:51'!
commit: aBlock
	self subclassResponsibility! !

!VORepository methodsFor: 'testing' stamp: 'EstebanLorenzano 11/2/2010 16:57'!
isNew: anObject
	self subclassResponsibility! !

!VORepository methodsFor: 'persistence' stamp: 'EL 7/3/2008 08:52'!
remove: anObject
	self subclassResponsibility! !

!VORepository methodsFor: 'persistence' stamp: 'EL 2/4/2009 19:36'!
removeAll: aClass
	self subclassResponsibility! !

!VORepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 1/11/2011 11:30'!
root: anObject commit: aBlock
	"Specifies a root object, to perform better transactions. 
	 In many cases (as in memory repository, or relational based repository) this is the same as plain #commit:"
	self commit: aBlock! !

!VORepository methodsFor: 'persistence' stamp: 'EL 7/3/2008 08:52'!
save: anObject
	self subclassResponsibility! !

!VORepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/29/2009 10:35'!
selectAll: aClass
	self selectAll: aClass sortBy: nil! !

!VORepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/29/2009 10:53'!
selectAll: aClass sortBy: sortBlockOrSymbol
	self subclassResponsibility.! !

!VORepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/29/2009 10:36'!
selectMany: aClass where: aBlock
	self selectMany: aClass where: aBlock sortBy: nil! !

!VORepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/29/2009 10:53'!
selectMany: aClass where: aBlock sortBy: sortBlockOrSymbol
	self subclassResponsibility.! !

!VORepository methodsFor: 'persistence' stamp: 'EL 7/23/2008 12:32'!
selectOne: aClass where: aBlock
	self subclassResponsibility.! !

Object subclass: #VORepositoryContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Model-Core'!

!VORepositoryContainer methodsFor: 'accessing' stamp: 'EL 7/7/2008 12:58'!
repository
	^self subclassResponsibility! !

!VORepositoryContainer methodsFor: 'accessing' stamp: 'EL 7/7/2008 14:04'!
repository: aRepository
	self subclassResponsibility! !

VORepositoryContainer subclass: #VOSingletonContainer
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Model-Core'!

!VOSingletonContainer class methodsFor: 'instance creation' stamp: 'EL 7/7/2008 13:01'!
repository: aRepository
	^self new
		repository: aRepository;
		yourself! !

!VOSingletonContainer methodsFor: 'accessing' stamp: 'EL 7/7/2008 12:59'!
repository
	^repository! !

!VOSingletonContainer methodsFor: 'accessing' stamp: 'EL 7/7/2008 12:59'!
repository: aRepository
	repository := aRepository! !
